
#ifndef STRINGBUF_H
#define STRINGBUF_H 1

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

/* stdlib.h includes stddef.h which in turn defines size_t */
#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

struct stringbuf {
    char *buf;
    size_t len;
    size_t allocated;
};

typedef struct stringbuf stringbuf;

struct stringbuf *new_stringbuf (char *str);

int free_stringbuf (struct stringbuf *);

struct stringbuf *dup_stringbuf (struct stringbuf *buf);

struct stringbuf *catc_stringbuf (struct stringbuf *buf, char c);

struct stringbuf *cat_stringbuf (struct stringbuf *buf, char *str);

struct stringbuf *shrink_stringbuf (struct stringbuf *buf, size_t newlen);


#endif /* STRINGBUF_H */
