/* 
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   Copyright (c) Alexey Mahotkin <alexm@hsys.msk.ru> 2001

   List of user permissions implementation

*/

#define _BSD_SOURCE 1

#include "config.h"

#include "cvsgroup.h"
#include "user-acl.h"

#include <stdlib.h>
#include <string.h>

USER_ACE *
get_user_ace (USER_ACL *acls, char *username)
{
    USER_ACL *acl = acls;

    while (acl != NULL) {
	if (strcmp(acl->username, username) == 0)
	    return acl;

	if ((acl->username[0] == '%') && user_in_group(username, acl->username))
	    return acl;

	acl = acl->next;
    }

    return NULL;
}

USER_ACL *
set_user_ace (USER_ACL *acls, char *username, int perm)
{
    USER_ACL *acl = acls;

    while (acl != NULL) {
	if (strcmp(acl->username, username) == 0) {
	    acl->perm = perm;
	    return acls;
	}
	acl = acl->next;
    }

    acl = (USER_ACL *) calloc(1, sizeof(USER_ACE));
    if (acl == NULL)
	return NULL;

    acl->username = strdup(username);
    if (acl->username == NULL) {
	free(acl);
	return NULL;
    }
    acl->perm = perm;
    acl->next = acls;

    return acl;
}

