/* 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.  
   
   Copyright (C) Alexey Mahotkin <alexm@hsys.msk.ru> 2000

   Contains common routines for cvs-nserver and cvs-pserver.

*/

#include <stdio.h>
#include <stdlib.h>

#ifdef HAVE_STRING_H
#include <string.h>
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#include "cvs-server.h"

char *
get_buffer (char *buffer, int bufsize)
{
    char *p;

    if (!fgets(buffer, bufsize, stdin))
	exit(EXIT_FAILURE);

    if (strlen(buffer) == 0)
	exit(EXIT_FAILURE);		/* assertion */

    p = buffer + strlen(buffer) - 1;

    if (*p == '\n')
	*p-- = '\0';			/* strip trailing newline */

    if (p > buffer)
	if (*p == '\r')
	    *p-- = '\0';		/* strip trailing carriage return */

    return buffer;
}

char*
strip_trailing_slash (char *repository)
{
    char *p;

    if (strlen(repository) != 0)
    {
	p = repository + strlen(repository) - 1;
	
	if (*p == '\\')
	    *p = '\0';
    }

    return repository;
}

int
repository_ok (char *repository, int argc, char *argv[])
{
    int i;

    for (i = 1; i < argc; i++)
    {
	if (strcmp(argv[i], "--") == 0)
	    return 0;
	if (strcmp(repository, argv[i]) == 0)
	    return 1;
    }

    return 0;
}

int
create_pipe (int pi[2])
{
    if (fd_copy (2, 1) == -1)
	return 0;

    close (3);
    
    if (pipe(pi) == -1)
	return 0;

    if (pi[0] != 3)
	return 0;

    return 1;
}

