/*
 * You may distribute under the terms of the GNU General Public License as
 * specified in the README file that comes with the CVS source distribution.
 * 
 */

#ifndef CVSROOT_H
#define CVSROOT_H

/* Access method specified in CVSroot. */

typedef enum {
    null_method,
    local_method,
    server_method,
    pserver_method,
    sslpserver_method,
    nserver_method,
    sslnserver_method,
    kserver_method,
    gserver_method,
    ext_method,
    fork_method
} CVSmethod;

extern char* method_names[];

typedef struct cvsroot_s {
    char *original;		/* the complete source CVSroot string */
    CVSmethod method;		/* one of the enum values above */
    char *username;		/* the username or NULL if method == local */
    char *password;		/* the username or NULL if method == local */
    char *hostname;		/* the hostname or NULL if method == local */
    int port;			/* the port or zero if method == local */
    char *directory;		/* the directory name */
#ifdef CLIENT_SUPPORT
    unsigned char isremote;	/* nonzero if we are doing remote access */
#endif /* CLIENT_SUPPORT */
} cvsroot_t;

extern cvsroot_t *current_parsed_root;


int method_needs_password (int method);

#endif /* CVSROOT_H */
