/*
 * Copyright (c) 1992, Brian Berliner and Jeff Polk
 * 
 * You may distribute under the terms of the GNU General Public License as
 * specified in the README file that comes with the CVS source distribution.
 * 
 * General recursion handler
 * 
 */

#ifndef RECURSE_H
#define RECURSE_H 1


typedef	int (*FILEPROC) (void *callerdat, struct file_info *finfo);

typedef	int (*FILESDONEPROC) (void *callerdat, int err,
			      char *repository, char *update_dir,
			      List *entries);

typedef	Dtype (*DIRENTPROC) (void *callerdat, char *dir,
			     char *repos, char *update_dir,
			     List *entries);

typedef	int (*DIRLEAVEPROC) (void *callerdat, char *dir, int err,
			     char *update_dir, List *entries);

typedef int (*PERMPROC) (const char *dir);


int start_recursion (FILEPROC fileproc, FILESDONEPROC filesdoneproc,
		     DIRENTPROC direntproc, DIRLEAVEPROC dirleaveproc,
		     void *callerdat,
		     int argc, char *argv[], int local, int which,
		     int aflag, int readlock, char *update_preload,
		     int dosrcs);


#endif /* RECURSE_H */
